package servlet;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.lang.reflect.Method;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.imageio.ImageIO;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;


import util.ImageUtil;

public class BaseBackServlet extends HttpServlet{
    protected void service(HttpServletRequest request,
    		HttpServletResponse response){ 	
    	    try {
    	    	String method=(String) request.getAttribute("method");
    		    Method m=this.getClass().getMethod(method, 
    		    		HttpServletRequest.class,HttpServletResponse.class);
    		    m.invoke(this, request,response);
			} catch (Exception e) {
				// TODO: handle exception
			}
		
    }
    /*ܣܱύĶļĸFileֶΡ
     * upload
     * 1request
     * 2response
     * 3params洢type!="file"Filename value.
     * أtype="file"File
     * */
    public InputStream upload(HttpServletRequest request,
    		Map<String, String> params){
    	InputStream is=null;
    	try {
    		 DiskFileItemFactory factory = new DiskFileItemFactory();
	         ServletFileUpload upload = new ServletFileUpload(factory);
	         factory.setSizeThreshold(1024 * 10240);
	         
	         List items = upload.parseRequest(request);
	         Iterator iter = items.iterator();
	         while (iter.hasNext()) {
	        	 FileItem item = (FileItem) iter.next();
	        	 if (!item.isFormField()) {//ֶΪϴļֶ
	        		 is = item.getInputStream();
	        		 
	        	 }else{//ֶͨ
	        		 String paramName = item.getFieldName();
	                 String paramValue = item.getString();
	                 paramValue = new String(paramValue.getBytes("ISO-8859-1"), "UTF-8");
	                 //һݵĲ
	             	params.put(paramName, paramValue);
	        	 }
	         }
    	}catch (Exception e) {
				// TODO: handle exception
		}
    	return is;
    }
    /*ύļͼƬ*/
    public void saveUplod(HttpServletRequest request,InputStream is,int id,String context) throws Exception{
    	//ʵļϴ˴ļָͼƬ
		 String imageFolder =request.getSession().getServletContext().getRealPath(context);
		// System.out.println("imageFolder"+imageFolder);
		 String filename = id+".jpg";
		 File f = new File(imageFolder, filename);
		// ļ
		 if(null!=is && 0!=is.available()){
			 FileOutputStream fos = new FileOutputStream(f); 
			 byte b[] = new byte[1024 * 1024];
		     int length = 0;
		     while (-1 != (length = is.read(b))) {
		           fos.write(b, 0, length);
		     }
		     fos.flush(); 
		     //룬ͼƬļjpgʽ
		     BufferedImage img = ImageUtil.change2jpg(f);
		     ImageIO.write(img, "jpg", f); 
		     //ıͼƬС
		     if(context.equals("Single_middle")){
		    	 ImageUtil.resizeImage(f, 217, 190, f);
		     }
		     if(context.equals("Single_small")){
		    	 ImageUtil.resizeImage(f, 56, 56, f);
		     }
		 } 
    }
    /*ʵַҳ*/
    public void listPage(int start,int count, int total){
    	
    }
}
