<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>

<%
        String path = request.getContextPath();
        String basePath = request.getScheme() + "://" + request.getServerName() + ":" +     
        request.getServerPort() + path + "/";
%>
<base href="<%=basePath%>">

<script src="<%=basePath%>/js/jquery/2.0.0/jquery.min.js"></script>
<link href="<%=basePath%>/css/bootstrap/3.3.6/bootstrap.min.css" rel="stylesheet"/>
<script src="<%=basePath%>/js/bootstrap/3.3.6/bootstrap.min.js"></script>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>分类管理</title>


</head>
<body>
<br/><br/>
<div class="label label-info">分类管理</div>
<br/><br/>
<table class="table table-striped  table-bordered table-hover  table-condensed">
    <thead>
        <tr class="success">
        <td>ID</td>
        <td>图片</td>
        <td>分类名称</td>
        <td>属性管理</td>
        <td>产品管理</td>
        <td>编辑</td>
        <td>删除</td>
    </tr>
    </thead>
    <tbody>
        <c:forEach  items="${categories}"  var="categorie">
        <tr>
            <td>${categorie.id}</td>
            <td><img height="40px" src="img/category/${categorie.id}.jpg"></td>
            <td>${categorie.name}</td>
            <td><a href="admin_property_list?cid=${categorie.id}"><span class="glyphicon glyphicon-th-list"></span></a></td>
            <td><a href="admin_product_list?cid=${categorie.id}"><span class="glyphicon glyphicon-th-list"></span></a></td>
            <td><a href="admin_category_edit?id=${categorie.id}"><span class="glyphicon glyphicon-edit"></span></a></td>
            <td><a href="admin_category_delete?id=${categorie.id}"><span class="glyphicon glyphicon-remove"></span></a></td>
        </tr>  
        </c:forEach>  
    </tbody>
    <tfoot>
        <tr>
            <td colspan="6" align="center">
                <!-- 点击超链接时，相当于提交了一个带有参数start的请求 -->
                <a href="admin_category_list?start=0">[首页]</a>
                <a href="admin_category_list?start=${pre}">[上一页]</a>
                <!-- 中间页 -->
                <a href="admin_category_list?start=0">[1]</a>
                <c:if test="${page-1>1}">
                    <c:forEach var="i" begin="2" end="${page-1}">
                    <a href="admin_category_list?start=${(i-1)*count}">[${i}]</a>
                    </c:forEach>
                </c:if>
                <c:if test="${last>1}">
                    <a href="admin_category_list?start=${last}">[${page}]</a>
                </c:if>
                <!-- 中间页 -->
                <a href="admin_category_list?start=${next}">[下一页]</a>
                <a href="admin_category_list?start=${last}">[末页]</a>
            </td>
        </tr>
    </tfoot>
</table>






<br><br>
<div class="panel panel-warning">
  <div class="panel-heading">新增分类</div>
  <div class="panel-body">
      <!-- 面板内容 -->
      <form action="admin_category_add" method="post" enctype="multipart/form-data">
          <table>
              <tr>
                  <td>分类名称</td>
                  <td><input id="a"  type="text"  name="name"  class="form-control"></td>
              </tr>
              <tr>
                  <td>分类图片</td>
                  <td><input id="b"  type="file"  accept="image/*" name="filepath"></td>
              </tr>
              <tr>
                  <td colspan="2" align="center">
                      <button type="submit" class="btn btn-success">提交</button>
                  </td>
              </tr>                                       
          </table>          
      </form>
  </div>
</div>



</body>
</html>