<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>

<%
        String path = request.getContextPath();
        String basePath = request.getScheme() + "://" + request.getServerName() + ":" +     
        request.getServerPort() + path + "/";
%>
<base href="<%=basePath%>">

<script src="<%=basePath%>/js/jquery/2.0.0/jquery.min.js"></script>
<link href="<%=basePath%>/css/bootstrap/3.3.6/bootstrap.min.css" rel="stylesheet"/>
<script src="<%=basePath%>/js/bootstrap/3.3.6/bootstrap.min.js"></script>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>产品管理</title>


</head>
<body>
<br/><br/>
<div class="label label-info">产品管理</div>
<br/><br/>
<table class="table table-striped  table-bordered table-hover  table-condensed">
    <thead>
        <tr class="success">
        <td>ID</td>
        <td>图片</td>
        <td>产品名称</td>
        <td>产品小标题</td>
        <td>原价格</td>
        <td>优惠价格</td>
        <td>库存数量</td>
        <td>图片管理</td>
        <td>编辑</td>
        <td>删除</td>
    </tr>
    </thead>
    <tbody>
        <c:forEach  items="${products}"  var="product">
        <tr>
            <td>${product.id}</td>
            <td>
            <c:if test="${!empty product.firstProductImage}">
				<img width="40px" src="img/productSingle/${product.firstProductImage.id}.jpg">
		    </c:if>
		    </td>
            <td>${product.name}</td>
            <td>${product.subTitle}</td>
            <td>${product.orignalPrice}</td>
            <td>${product.promotePrice}</td>
            <td>${product.stock}</td>        
            <td><a href="admin_productImage_list?pid=${product.id}"><span class="glyphicon glyphicon-th-list"></span></a></td>
            <td><a href="admin_product_edit?id=${product.id}&&cid=${c.id}"><span class="glyphicon glyphicon-edit"></span></a></td>
            <td><a href="admin_product_delete?id=${product.id}&&cid=${c.id}"><span class="glyphicon glyphicon-remove"></span></a></td>
        </tr>  
        </c:forEach>  
    </tbody>
    <tfoot>
        <tr>
            <td colspan="10" align="center">
                <!-- 点击超链接时，相当于提交了一个带有参数start的请求 -->
                <a href="admin_product_list?start=0&&cid=${c.id}">[首页]</a>
                <a href="admin_product_list?start=${pre}&&cid=${c.id}">[上一页]</a>
                <!-- 中间页 -->
                <a href="admin_product_list?start=0&&cid=${c.id}">[1]</a>
                <c:if test="${page-1>1}">
                    <c:forEach var="i" begin="2" end="${page-1}">
                    <a href="admin_product_list?start=${(i-1)*count}&&cid=${c.id}">[${i}]</a>
                    </c:forEach>
                </c:if>
                <c:if test="${last>1}">
                    <a href="admin_product_list?start=${last}&&cid=${c.id}">[${page}]</a>
                </c:if>
                <!-- 中间页 -->
                <a href="admin_product_list?start=${next}&&cid=${c.id}">[下一页]</a>
                <a href="admin_product_list?start=${last}&&cid=${c.id}">[末页]</a>
            </td>
        </tr>
    </tfoot>
</table>






<br><br>
<div class="panel panel-warning">
  <div class="panel-heading">新增产品</div>
  <div class="panel-body">
      <!-- 面板内容 -->
      <form action="admin_product_add"  method="post" >
          <table>
              <tr>
                  <td>产品名称</td>
                  <td><input id="a"  type="text"  name="name"  class="form-control"></td>
              </tr> 
               <tr>
                  <td>产品小标题</td>
                  <td><input id="b"  type="text"  name="subTitle"  class="form-control"></td>
              </tr> 
               <tr>
                  <td>原价格</td>
                  <td><input id="c"  type="text"  name="orignalPrice"  class="form-control"></td>
              </tr> 
               <tr>
                  <td>优惠价格</td>
                  <td><input id="d"  type="text"  name="promotePrice"  class="form-control"></td>
              </tr> 
               <tr>
                  <td>库存</td>
                  <td><input id="e"  type="text"  name="stock"  class="form-control"></td>
              </tr>     
              <tr>
                  <td colspan="2" align="center">
                      <input type="hidden" name="cid" value="${c.id}">
                      <button type="submit" class="btn btn-success">提交</button>
                  </td>
              </tr>                                       
          </table>          
      </form>
  </div>
</div>



</body>
</html>