<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>

<%
        String path = request.getContextPath();
        String basePath = request.getScheme() + "://" + request.getServerName() + ":" +     
        request.getServerPort() + path + "/";
%>
<base href="<%=basePath%>">

<script src="<%=basePath%>/js/jquery/2.0.0/jquery.min.js"></script>
<link href="<%=basePath%>/css/bootstrap/3.3.6/bootstrap.min.css" rel="stylesheet"/>
<script src="<%=basePath%>/js/bootstrap/3.3.6/bootstrap.min.js"></script>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>图片管理</title>


</head>
<body>
<br/><br/>
<div class="label label-info">图片管理</div>
<br/><br/>

<div class="container">
	<div class="row clearfix">
			<div class="col-md-6 column">
				<div class="panel panel-warning">
					<div class="panel-heading">
						<h3 class="panel-title">新增产品单个图片</h3>
					</div>
					<div class="panel-body">
						<!-- 面板内容 -->
						<form action="admin_productImage_add" method="post"
							enctype="multipart/form-data">
							<table>
								<tr>请选择本地图片 尺寸400X400为佳
								</tr>
								<tr>
									<td>图片</td>
									<td>
									<input id="a" type="file" accept="image/*"
										name="filepath"></td>
								</tr>
								<tr>
									<td colspan="10" align="center">
									    <input type="hidden" name="type" value="type_single">
									    <input type="hidden" name="pid" value="${pid}">
										<button type="submit" class="btn btn-success">提交</button></td>
								</tr>
							</table>
						</form>
					</div>
				</div>
				<div class="row clearfix">
					<div class="col-md-12 column">
						<table
							class="table table-striped  table-bordered table-hover  table-condensed">
							<thead>
								<tr class="success">
									<td>ID</td>
									<td>产品单个图片缩略图</td>
									<td>删除</td>
								</tr>
							</thead>
							<tbody>
								<c:forEach items="${productSingleImages}" var="productSingleImage">
									
										<tr>
											<td>${productSingleImage.id}</td>
											<td><img height="40px" src="img/productSingle/${productSingleImage.id}.jpg"></td>
											<td><a
												href="admin_productImage_delete?id=${productSingleImage.id}&&pid=${pid}"><span
													class="glyphicon glyphicon-remove"></span></a></td>
										</tr>
									
								</c:forEach>
							</tbody>
						</table>
					</div>
				</div>
			</div>
			<div class="col-md-6 column">
				<div class="panel panel-warning">
					<div class="panel-heading">
						<h3 class="panel-title">新增产品详情图片</h3>
					</div>
					<div class="panel-body">
						<!-- 面板内容 -->
						<form action="admin_productImage_add" method="post"
							enctype="multipart/form-data">
							<table>
								<tr>请选择本地图片 宽度790为佳
								</tr>
								<tr>
									<td>图片</td>
									<td><input id="b" type="file" accept="image/*"
										name="filepath"></td>
								</tr>
								<tr>
									<td colspan="10" align="center">
									    <input type="hidden" name="type" value="type_detail">
									    <input type="hidden"  name="pid" value="${pid}">
										<button type="submit" class="btn btn-success">提交</button></td>
								</tr>
							</table>
						</form>
					</div>
				</div>
				<div class="row clearfix">
					<div class="col-md-12 column">
						<table
							class="table table-striped  table-bordered table-hover  table-condensed">
							<thead>
								<tr class="success">
									<td>ID</td>
									<td>产品详情图片缩略图</td>
									<td>删除</td>
								</tr>
							</thead>
							<tbody>
								<c:forEach items="${productDetailImages}" var="productDetailImage">
									
										<tr>
											<td>${productDetailImage.id}</td>
											<td><img height="40px" src="img/productDetail/${productDetailImage.id}.jpg"></td>
											<td><a
												href="admin_productImage_delete?id=${productDetailImage.id}&&pid=${pid}"><span
													class="glyphicon glyphicon-remove"></span></a></td>
										</tr>
								</c:forEach>
							</tbody>
						</table>
					</div>
				</div>
			</div>
	</div>
</div>
</body>
</html>