package servlet;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.transform.ErrorListener;

import bean.Category;
import bean.Product;
import bean.ProductImage;
import dao.CategoryDAO;
import dao.ProductDAO;
import dao.ProductImageDAO;

public class ProductImageServlet extends BaseBackServlet{
	 public void delete(HttpServletRequest request,HttpServletResponse response) throws IOException{
	    	int id=Integer.parseInt(request.getParameter("id"));
	    	new ProductImageDAO().delete(id);
	    	
	    	String filePath=request.getSession().getServletContext().getRealPath("img/productImage");
	    	String fileName=id+".jpg";
	    	File imageFile = new File(filePath+"/"+fileName);
	    	imageFile.delete();
	    	
	    	int pid=Integer.parseInt(request.getParameter("pid"));
	    	response.sendRedirect("admin_productImage_list?pid="+pid);
	    }
	public void add(HttpServletRequest request,HttpServletResponse response) throws Exception{
		Map<String, String> params=new HashMap<>();
		InputStream is=null;
    	ProductImage productImage=new ProductImage();
    	//
    	is=super.upload(request,params);
    	//
    	productImage.setType(params.get("type"));
    	int pid=Integer.parseInt(params.get("pid"));
    	productImage.setProduct(new ProductDAO().get(pid));
    	new ProductImageDAO().add(productImage);
    	//ύͼƬ
    	int id=productImage.getId();
    	String type=params.get("type");
    	char c=type.charAt(5);
    	String context="img/product"+Character.toUpperCase(c)+type.substring(6);
    	System.out.println("ļ֣"+context);
    	if(type.equals("type_single")){
    		super.saveUplod(request, is, id,context);		
    		super.saveUplod(request, is, id,context+"_middle");
    		super.saveUplod(request, is, id,context+"_small");
    	}else {
    		super.saveUplod(request, is, id,context);
		}	   	
    	response.sendRedirect("admin_productImage_list?pid="+pid);
	}
	public void list(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException{
    	
    	
    	
    	
    	int pid=Integer.parseInt(request.getParameter("pid"));
    	List<ProductImage>productSingleImages=new ProductImageDAO().list(pid,"type_single");
    	List<ProductImage>productDetailImages=new ProductImageDAO().list(pid,"type_detail");
    	
    	
    	request.setAttribute("pid", pid);
    	request.setAttribute("productSingleImages", productSingleImages);//categoriesݸjsp
    	request.setAttribute("productDetailImages", productDetailImages);//categoriesݸjsp
    	request.getRequestDispatcher("/admin/productimage/productImageList.jsp").forward(request, response);
    
    }
}
